/* *************************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
************************************************************************************* */

#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <stdlib.h> 
#include <math.h>

#include "myString.h"
#include "myException.h"

// *********************************************************************************

MyString::MyString()
{
	value = NULL;
	Zero();
}

MyString::MyString(char letter)
{
	value = NULL;
	*this=letter;
}

MyString::MyString(int integer)
{
	value = NULL;
	*this=integer;
}

MyString::MyString(long linteger)
{
	value = NULL;
	*this=linteger;
}

MyString::MyString(float floating)
{
	value = NULL;
	*this=floating;
}

MyString::MyString(double lfloating)
{
	value = NULL;
	*this=lfloating;
}

MyString::MyString(char *string)
{
	value = NULL;
	*this=string;
}

MyString::MyString(MyString &string)
{
	value = NULL;
	*this=string;
}

// *********************************************************************************

void MyString::Delete()
{
	if (value) delete []value;
	size = 0;
	allocSize = 0;
	value = NULL;
}

// *********************************************************************************

MyString & MyString::operator=(char letter) // string.operator=(char letter);
{
	Delete();
	size = 1;
	allocSize = 2;
	value = new char[allocSize];
	if (!value) throw MyExceptionMemory("MyString","operator=",allocSize);
	value[0]= letter;
	value[1]= '\0';
	return *this; // pour: s=t=u="coucou";
}

MyString & MyString::operator=(int integer)
{
	char temp[40];
	sprintf (temp,"%d",integer);
	*this = temp;
	return *this;
}

MyString & MyString::operator=(long linteger)
{
	char temp[80];
	sprintf (temp,"%d",linteger);
	*this = temp;
	return *this;
}

MyString & MyString::operator=(float floating)
{
	char temp[40];
	sprintf(temp,"%g",floating);
	*this = temp;
	return *this;
}

MyString & MyString::operator=(double lfloating)
{
	char temp[40];
	sprintf(temp,"%g",lfloating);
	*this = temp;
	return *this;
}

MyString & MyString::operator=(char *string) // string.operator=(char *string);
{
	Delete();
	if (!string) return *this;
	size= (long)strlen(string);
	allocSize = size +1;
	value = new char[allocSize];
	if (!value) throw MyExceptionMemory("MyString","operator=(char *)",allocSize);
	strcpy(value,string);
	return *this; // pour: s=t=u="coucou";
}

MyString & MyString::operator=(MyString &string)
{
	Delete();
	size = string.size;
	allocSize = size +1;
	value = new char[allocSize];
	if (!value) throw MyExceptionMemory("MyString","operator=(MyString &)",allocSize);
	strcpy (value,string.value);
	return *this;
}

// *********************************************************************************

BOOL MyString::operator==(char letter) 
{
	MyString temp = letter;
	return !strcmp (value,temp.value);
}

BOOL MyString::operator==(int integer) 
{
	MyString temp = integer;
	return !strcmp (value,temp.value);
}

BOOL MyString::operator==(long linteger) 
{
	MyString temp = linteger;
	return !strcmp (value,temp.value);
}

BOOL MyString::operator==(float floating) 
{
	MyString temp = floating;
	return !strcmp (value,temp.value);
}

BOOL MyString::operator==(double lfloating) 
{
	MyString temp = lfloating;
	return !strcmp (value,temp.value);
}

BOOL MyString::operator==(char *string) 
{
	if (!string) return FALSE;
	return !strcmp (value,string);
}

BOOL MyString::operator==(MyString &string)
{
	return !strcmp (value,string.value);
}

// *********************************************************************************

void MyString::operator+=(char letter) 
{
	// Celle solution n'inserais pas les '\0'
	MyString temp = letter;
	*this += temp;

	// Cette solution insert le '\0' mais les strcpy ne repsect plus alors le '\0'
	// Resize (size+1,TRUE);
	// value[size]=letter;
	// size+= 1;
}

void MyString::operator+=(int integer)
{
	MyString temp = integer;
	*this += temp;
}

void MyString::operator+=(long linteger)
{
	MyString temp = linteger;
	*this += temp;
}

void MyString::operator+=(float floating)
{
	MyString temp = floating;
	*this += temp;
}

void MyString::operator+=(double lfloating)
{
	MyString temp = lfloating;
	*this += temp;
}

void MyString::operator+=(char *string)
{
	if (!string) { *this; return; }

	long addSize = (long)strlen(string);
	Resize (size+addSize,TRUE);
	strcat (value,string);
	size+= addSize;
}

// *********************************************************************************

MyString operator+(MyString &string1,char *string2)
{
	MyString temp = string1;
	if (!string2) return temp;
	temp += string2;
	return temp;
}

// *********************************************************************************

MyString operator+(char *string1,MyString &string2)
{
	MyString temp;
	if (!string1)
	{
		temp = string2;
		return temp;
	}
	temp = string1;
	temp += string2;
	return temp;
}

// *********************************************************************************

MyString operator+(MyString &string,char letter)
{
	MyString temp = string;
	temp += letter;
	return temp;
}

MyString operator+(char letter,MyString &string)
{
	MyString temp = letter;
	temp += string;
	return temp;
}

MyString operator+(MyString &string,int integer)
{
	MyString temp = string;
	temp += integer;
	return temp;
}

MyString operator+(int integer,MyString &string)
{
	MyString temp = integer;
	temp += string;
	return temp;
}

MyString operator+(MyString &string,long linteger)
{
	MyString temp = string;
	temp += linteger;
	return temp;
}

MyString operator+(long linteger,MyString &string)
{
	MyString temp = linteger;
	temp += string;
	return temp;
}

MyString operator+(MyString &string,float floating)
{
	MyString temp = string;
	temp += floating;
	return temp;
}

MyString operator+(float floating,MyString &string)
{
	MyString temp = floating;
	temp += string;
	return temp;
}

MyString operator+(MyString &string,double lfloating)
{
	MyString temp = string;
	temp += lfloating;
	return temp;
}

MyString operator+(double lfloating,MyString &string)
{
	MyString temp = lfloating;
	temp += string;
	return temp;
}

MyString operator+(MyString &string1,MyString &string2)
{
	MyString temp = string1;
	temp += string2;
	return temp;
}

/*!
\brief Access a un element du text

Ex.:
\code
MyString temp = "coucou";
if (temp[1]=='o') temp[2]='i';
// temp == "coicou"
\endcode
*/
char &MyString::operator [] (int index)
{
	static char error='\0';
	index = GetPositionFromLeft(index);
	if (index!=-1) return value[index];
	else return error;
/*
	MyString temp;
	temp <<"out of bounds: index <> [-"<<size<<";"<<size<<"]";
	throw CMyException("MyString","operator[](int)",temp);
*/
}

// *********************************************************************************

MyString & operator << (MyString& string , char letter)
{
	string += letter;
	return string;
}

MyString & operator << (MyString& string , int integer)
{
	string += integer;
	return string;
}

MyString & operator << (MyString& string , long linteger)
{
	string += linteger;
	return string;
}

MyString & operator << (MyString& string , float floating)
{
	string += floating;
	return string;
}

MyString & operator << (MyString& string , double lfloating)
{
	string += lfloating;
	return string;
}

MyString & operator << (MyString& string1 , char *string2)
{
	string1 += string2;
	return string1;
}

MyString & operator << (MyString& string1 , MyString &string2)
{
	string1 += string2;
	return string1;
}

// *********************************************************************************

BOOL MyString::Resize()
{
	return Resize((int)strlen(value),TRUE);
}

// *********************************************************************************

BOOL MyString::Resize(int newSize,BOOL recopy)
{
	if (newSize<0) newSize=0;
	char *newValue = new char[newSize+1];
	if (!newValue) throw MyExceptionMemory("MyString","Resize",newSize+1);
	if (recopy && value) 
	{
		int curSize = min(newSize,allocSize-1);
		strncpy(newValue,value,newSize);
		newValue[curSize]='\0';
		Delete();
		size = curSize;
		allocSize = newSize+1;
	}
	else 
	{
		Delete();
		size = 0;
		allocSize = newSize+1;
		newValue[0]='\0';
	}
	value = newValue;
	return TRUE;
}

/*!
\brief Decomposition d'une chaine par un modele

Ex.:      "c:\mp3\album\clapton\"
index deb  1  2   3     4
index fin  -4 -3  -2    -1

\code
SubStringBeforToken(-1,result,"\\:") ==> result: "clapton"
\endcode
*/
BOOL MyString::SubStringBeforToken(int numSubString,MyString &result,char *lstToken)
{
	int indexCur=0;
	int posIndex = size;
	int sizeLstToken = (int)strlen(lstToken);
	int signe = numSubString<0 ? -1 : 1;
	for (int i=numSubString<0;i<size;i++)
	{
		for (int j=0;j<sizeLstToken;j++)
		{
			if (*this[i*size]==lstToken[j])
			{
				indexCur += signe;
				if (indexCur==numSubString)
				{
					posIndex = i-signe;
					CopyTo(result,i+signe,labs(posIndex-i));
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

// *********************************************************************************

char * MyString::GetValue(int index)
{
	if (index>=0 && index<size) return value+index;
	if (index<0 && index>=-size) return value+size+index;

	MyString temp;
	temp <<"out of bounds: index <> [-"<<size<<";"<<size<<"]";
	throw MyException("MyString","GetValue[](int)",temp);

}

/*!
\brief Recopy d'une chaine

\todo a verifier le calcul me parais suspect
*/
BOOL MyString::CopyTo(MyString &result,int index,int sizeToCopy)
{
	int signe = index<0 ? -1 : 1;
	int indexReal = index+sizeToCopy*signe;
	if (sizeToCopy==-1) sizeToCopy = size-index;
	char oldLetter = operator[](indexReal);
	operator[](indexReal)='\0';
	result.Resize(sizeToCopy);
	result=GetValue(index);
	operator[](indexReal) = oldLetter;
	return TRUE;
}

// *********************************************************************************

void MyString::SplitPath(MyString *drive,MyString *dir,MyString *file,MyString *ext,MyString *driveDir,MyString *fileExt)
{
   char _drive[_MAX_DRIVE];
   char _dir[_MAX_DIR];
   char _file[_MAX_FNAME];
   char _ext[_MAX_EXT];

   _splitpath(value,(drive||driveDir)?_drive:NULL,(dir||driveDir)?_dir:NULL,(file||fileExt)?_file:NULL,(ext||fileExt)?_ext:NULL);

   if (drive) *drive=_drive;
   if (dir) *dir=_dir;
   if (file) *file=_file;
   if (ext) *ext=_ext;
   if (fileExt) { *fileExt<<clear<<_file<<_ext; }
   if (driveDir) { *driveDir<<clear<<_drive<<_dir; }
}

// *********************************************************************************

long MyString::ToInteger()
{
	long res;
	sscanf(value,"%d",&res);
	return res;
}

float MyString::ToFloat()
{
	float res;
	sscanf(value,"%f",&res);
	return res;
}

double MyString::ToDouble()
{
	double res;
	sscanf(value,"%lf",&res);
	return res;
}

// *********************************************************************************

BOOL MyString::FormatToNoCtrl()
{
	BOOL isChanged = FALSE;
	MyString temp;
	for (int i=0;i<size;i++)
	{
		if (value[i]>=32) temp+=value[i];
		else isChanged = TRUE;
	}
	*this=temp;
	return isChanged;
}

// *********************************************************************************

BOOL MyString::FormatToLower()
{
	BOOL isChanged = FALSE;
	for (int i=0;i<size;i++) 
		if (!islower(value[i]))
		{
			value[i] = tolower(value[i]);
			isChanged = TRUE;
		}
	return isChanged;
}

// *********************************************************************************

BOOL MyString::FormatToUpper()
{
	BOOL isChanged = FALSE;
	for (int i=0;i<size;i++) 
		if (!isupper(value[i]))
		{
			value[i] = toupper(value[i]);
			isChanged = TRUE;
		}
	return isChanged;
}

// *********************************************************************************

BOOL MyString::IsVisibleText()
{
	for (int i=0;i<size;i++)
	{
		if (value[i]>32 && value[i]!=255) return TRUE;
	}
	return FALSE;
}

// *********************************************************************************

void MyString::AddRepetitiveFormat(char *matrise,int nbCopy)
{
	for (int i=0;i<nbCopy;i++)
	{
		operator+=(matrise);
	}
}

/*!
\brief Transforme les positions 

ex.:
\code
// left count   012
// right count -321
MyString str= "012";
printf("%d",str.GetPositionFromLeft(1));	// 1
printf("%d",str.GetPositionFromLeft(-1));	// 2
printf("%d",str.GetPositionFromRight(1));	// -2
printf("%d",str.GetPositionFromRight(-1));	// -1
\endcode
*/
int MyString::GetPositionFromLeft(int pos)
{
	pos = pos>=0? pos: size+pos;
	return pos<size? pos : -1;
}

int MyString::GetPositionFromRight(int pos)
{
	if (pos>=0) return -size+pos;
	else return pos;
}

/*!
\brief Efface a partir de la position, avant ou apres d'un certain nombre de caracter ou delimit par un lettre a rechercher
ex.: 
\code
MyString str="0123456";
str.Delete(-1,FALSE,1); // 012345
str.Delete(1,TRUE,2);   // 0345
str.Delete(1,TRUE,'4'); // 05
\endcode
*/
BOOL MyString::Delete(int pos,BOOL after,char letterToFind)
{
	int posLeft = GetPositionFromLeft(pos);
	int posLeft2 = FindLetter(posLeft,after,letterToFind);
	if (posLeft2==-1) return FALSE;
	return Delete(pos,after,abs(posLeft-posLeft2)+1);
}

BOOL MyString::Delete(int pos,BOOL after,int nbLetter)
{
	int posLeft = GetPositionFromLeft(pos);
	if (!after) posLeft-=nbLetter-1;
	strncpy(value+posLeft,value+posLeft+nbLetter,size-posLeft-nbLetter);
	return Resize(size-nbLetter,TRUE);
}

/*!
\brief Ajoute un element a une position donne

Ex.: 
\code
MyString str="012";
str.Add(1,TRUE,'a'); // 01a2
str.Add(1,FALSE,-12.2); // 01-12.2a2
str.Add(-1,TRUE,"coucou"); // 01-12coucou
\endcode
*/
BOOL MyString::Add(int pos,BOOL after,char letter)
{
	MyString temp;
	int posLeft = GetPositionFromLeft(pos);
	CopyTo(temp,0,posLeft+!after);
	temp<<letter;
	temp<<value+posLeft+!after+1;
	operator=(temp);
	return TRUE;
}

BOOL MyString::Add(int pos,BOOL after,int integer)
{
	return TRUE;
}
BOOL MyString::Add(int pos,BOOL after,long linteger)
{
	return TRUE;
}
BOOL MyString::Add(int pos,BOOL after,float floating)
{
	return TRUE;
}
BOOL MyString::Add(int pos,BOOL after,double lfloating)
{
	return TRUE;
}
BOOL MyString::Add(int pos,BOOL after,char *string)
{
	return TRUE;
}
BOOL MyString::Add(int pos,BOOL after,MyString &string)
{
	return TRUE;
}

/*!
\brief Donne la position d'un lettre a partir de la pos de base dansla direction after avec comme model la letter

\return 
	- la postion par rapport a la gauche
	- -1 si pas de model trouv
*/

int MyString::FindLetter(int pos,BOOL after,char letter)
{
	int posLeft = GetPositionFromLeft(pos);

	if (after)
	{
		for (int i=posLeft;i<size;i++)
			if (value[i]==letter) return i;
	}
	else
	{
		for (int i=posLeft;i>=0;i--)
			if (value[i]==letter) return i;
	}
	return -1;
}

/*!
\brief Donne la position d'un lettre a partir de la gauche

\return 
	- la postion par rapport a la gauche
	- -1 si pas de model trouv
*/
int MyString::FindLetter(char letter)
{
	return FindLetter(0,TRUE,letter);
}

/*!
\brief Formate le text avec les parametre du printf()
*/
BOOL MyString::AddFormat(char *format,...)
{
	va_list args;
	int len;
	char *buffer;
	va_start(args,format);
	len = _vscprintf( format, args )+ 1; // _vscprintf doesn't count terminating '\0'
	buffer = (char *)malloc(len * sizeof(char));
	if (!buffer) return FALSE;
	vsprintf(buffer,format,args);
	operator+=(buffer);
	free(buffer);
	return TRUE;
}

/*!
\brief Recopie la chaine a partir d'une postion et d'une taille donne
*/
MyString MyString::Mids(int beginPos,int sizeToCopy)
{
	MyString result;
	if (beginPos+sizeToCopy>size) return result;
	char oldlLetter = value[beginPos+sizeToCopy];
	value[beginPos+sizeToCopy]='\0';
	result=value+beginPos;
	value[beginPos+sizeToCopy]=oldlLetter;
	return result;
}

BOOL MyString::Format(char *format,...)
{
	va_list args;
	int len;
	char *buffer;
	va_start(args,format);
	len = _vscprintf( format, args )+ 1; // _vscprintf doesn't count terminating '\0'
	buffer = (char *)malloc(len * sizeof(char));
	if (!buffer) return FALSE;
	vsprintf(buffer,format,args);
	operator=(buffer);
	free(buffer);
	return TRUE;
}

/*! 
\brief Test si le "model" est bien le debut du text
*/

BOOL MyString::IsBeginWith(char *model)
{
	return !strncmp(value,model,strlen(model));
}

/*!
\brief Test si le text est contenu dans la chaine en cours
\params caseSensitive: distingue les majuscule et minuscule

\return NULL si pas de sous string , charPtr si trouv
*/
char * MyString::TestSubString(char *text,BOOL caseSensitive)
{
	if (!caseSensitive)
	{
		MyString lowerThis(*this),lowerText(text);
		lowerThis.FormatToLower();
		lowerText.FormatToLower();
		return strstr(lowerText,lowerThis);
	}
	return strstr(text,value); 
}

/*!
\brief Lance un manipulateurs

Liste:
	- clear ==> efface
	- ret	==> retour a la ligne
*/
MyString & operator << (MyString& in ,FncManipulateur fnc)
{
	fnc(in);
	return in;
}

void clear (MyString &in)
{
	in.Zero();
}

void ret (MyString &in)
{
	in<<"\n";
}
