#include "stdafx.h"
#include "TabCtrl.h"

#include <shlwapi.h>
#include <commctrl.h>
#include <direct.h>
#include <windowsx.h>
#include <shellapi.h>

#include "mylist.h"


/* **********************************************************************************
********************************************************************************** */

CTabCtrl::CTabCtrl(HWND hWndTab)
{
	m_hWndTab = hWndTab;
	m_firstChild = TRUE;
}


/* **********************************************************************************
********************************************************************************** */

CTabCtrl::~CTabCtrl()
{
	Reset();
}


/* **********************************************************************************
********************************************************************************** */

BOOL CTabCtrl::Add (HWND hWndChildCurrent,char *title,BOOL show)
{
	if (!hWndChildCurrent || !title) return FALSE;
	
	TCITEM tcitem;
	tcitem.dwState = 0;
	tcitem.dwStateMask = 0;
	tcitem.mask = TCIF_TEXT;
	tcitem.pszText= title;
	tcitem.cchTextMax = strlen(title)+1;
	tcitem.iImage = -1;
	tcitem.lParam = NULL;

	if (TabCtrl_InsertItem(m_hWndTab,GetNbPage(),&tcitem) == -1) return FALSE;
	m_hWndChilds.AddLast(hWndChildCurrent);

	RECT rectTab,rect,rectClient;
	if (!TabCtrl_GetItemRect(m_hWndTab,GetNbPage()-1, &rectTab )) return FALSE;
	if (!GetClientRect (m_hWndTab, &rectClient)) return FALSE;
	if (!GetClientRect (hWndChildCurrent, &rect)) return FALSE;

	if (!MoveWindow (
		hWndChildCurrent, 
		1, 
		rectTab.bottom+1, 
		rectClient.right-2, 
		rectClient.bottom-rectTab.bottom-2, 
		FALSE )) return FALSE;

	if (m_firstChild) 
	{
		ShowWindow(hWndChildCurrent,SW_SHOWNORMAL);
		m_firstChild = FALSE;
	}
	else
	{
		if (show) ShowPage(GetNbPage()-1);
	}
	return TRUE;
}

BOOL CTabCtrl::Rename (int index, char *text)
{
	TCITEM tcitem;
	tcitem.mask = TCIF_TEXT;
	tcitem.pszText= text;
	return TabCtrl_SetItem(m_hWndTab,index,&tcitem);
}

/* **********************************************************************************
********************************************************************************** */

BOOL CTabCtrl::Sup(int index)
{
	m_hWndChilds.GoIndex(first,index);
	DestroyWindow(m_hWndChilds.GetElem());
	m_hWndChilds.SuprCurrent();
	return TabCtrl_DeleteItem(m_hWndTab,index);
}


/* **********************************************************************************
********************************************************************************** */

BOOL CTabCtrl::Reset()
{
	m_firstChild = TRUE;

	// envoie a tout les child WM_DESTORY (pour quitter)
	for (m_hWndChilds=0;m_hWndChilds.More();m_hWndChilds++) 
		DestroyWindow(m_hWndChilds.GetElem()); 

	m_hWndChilds.SuprAll();
	return TabCtrl_DeleteAllItems(m_hWndTab);
}


/* **********************************************************************************
********************************************************************************** */

int CTabCtrl::FindPage(char *title)
{
	int i;
    
	// config de la recherche
	char buffer[64];
	TCITEM item;
	item.mask = TCIF_TEXT;
	item.pszText = buffer;
	item.cchTextMax = 64;

	for (i=0;i<GetNbPage();i++)
	{
		if (!TabCtrl_GetItem(m_hWndTab,i,&item)) return -1;
		if (!strcmp(buffer,title)) return i;
	}
	return -1;
}


/* **********************************************************************************
********************************************************************************** */

HWND CTabCtrl::FindChild(char *title)
{
	int index = FindPage(title);
	if (index == -1) return 0;

	return FindChild(index);
}


/* **********************************************************************************
********************************************************************************** */

HWND CTabCtrl::FindChild(int index)
{
	m_hWndChilds.GoIndex(first,index);
	return m_hWndChilds.GetElem();
}


/* **********************************************************************************
********************************************************************************** */

BOOL CTabCtrl::Notify (WPARAM lParam)
{	
    switch (((LPNMHDR)lParam)->code)
	{ 
        case TCN_SELCHANGE: 
			ShowPage (GetCurPage()); 
			return TRUE;
	}
	return FALSE;
}


/* **********************************************************************************
********************************************************************************** */

int	CTabCtrl::GetCurPage()
{
	return TabCtrl_GetCurSel(m_hWndTab); 
}


/* **********************************************************************************
********************************************************************************** */

int	CTabCtrl::GetNbPage()
{
	return TabCtrl_GetItemCount(m_hWndTab); 
}


/* **********************************************************************************
********************************************************************************** */

BOOL CTabCtrl::ShowPage(int index)
{	
	if (index<0 || index>GetNbPage()) return FALSE;
	TabCtrl_SetCurSel(m_hWndTab,index);

	HWND hWnd;
	for (m_hWndChilds=0;m_hWndChilds.More();m_hWndChilds++)
		ShowWindow(m_hWndChilds.GetElem(),SW_HIDE);
		
	m_hWndChilds.GoIndex(first,index);
	hWnd = m_hWndChilds.GetElem();

	ShowWindow(hWnd,SW_SHOWNORMAL);
	return TRUE;
}


/* **********************************************************************************
********************************************************************************** */

void CTabCtrl::Highlight (int index,BOOL state)
{
	TabCtrl_HighlightItem(m_hWndTab,index,state);
}