// dllDependancy.cpp : Defines the entry point for the application.
//
#include <stdio.h>
#include <windows.h>
#include <winable.h>
#include "MyString.h"
#include "MyList.h"
#include "Psapi.h"
#pragma comment(lib, "Psapi.lib")
#include "dllDependancy.h"
#include "resource.h"
#include <commctrl.h> // pour InitCommonControls
#pragma comment(lib, "comctl32.lib")
#include <windowsx.h> // pour les Edit_SetText et autre ...

HINSTANCE hInst;

BOOL TreeView_SetItemText(HWND hWndTree,HTREEITEM hItem,char *text)
{
	TVITEM tvItem;
	tvItem.mask =  TVIF_TEXT;
	tvItem.hItem = hItem;
	tvItem.pszText = text;
	return TreeView_SetItem(hWndTree,&tvItem);
}

BOOL TreeView_GetItemText(HWND hWndTree,HTREEITEM hItem,char *text)
{
	TVITEM tvItem;

	// Prepare to receive the desired information.
	tvItem.mask = TVIF_HANDLE | TVIF_TEXT;
	tvItem.hItem = hItem;
	tvItem.cchTextMax = MAX_PATH;
	tvItem.pszText = text;

	// Request the information.
	return TreeView_GetItem(hWndTree,&tvItem);
}

// ajoute le text "[x*]" x etant le nombre de fils (n'ajoute rien s'il n'y a pas de fils)
int TreeView_InsertTextNbCount (HWND hTree,HTREEITEM hFirstTree)
{
	static MyString dest;
	static char source[MAX_PATH];
	HTREEITEM root,child;
	if (!hFirstTree) root=TreeView_GetRoot(hTree);
	else root=hFirstTree;
	int count = 0;
	int countChild;
	while (root)
	{
		count++;
		child = TreeView_GetChild(hTree,root);
		if (child) 
		{
			countChild = TreeView_InsertTextNbCount(hTree,child);
			TreeView_GetItemText(hTree,root,source);
			dest=source;
			dest<<"  ["<<countChild<<" elems]";
			TreeView_SetItemText(hTree,root,dest);
		}
		root = TreeView_GetNextSibling(hTree,root);
	}
	return count;
}

void FormatFileName(char *source)
{
	MyString str,result;
	MyString name,path;
	str=source;
	str.SplitPath(NULL,NULL,NULL,NULL,&path,&name);
	name.FormatToUpper();
	result<<name<<"   \""<<path<<"\"";
	strcpy(source,result);
}

/* Recherche si un element a la "value" entre 
si un separateur est definis, il donne le dernier caractere pris en compt
ex.: 
char text[]="coucou [12]";
TreeView_FindText (HWND hTree,NULL,text,"[");
==> item conteant "coucou ";
*/
HTREEITEM TreeView_FindText (HWND hTree,HTREEITEM hFirstTree,char *value,char *separators=NULL)
{
	char result[MAX_PATH];
	HTREEITEM rootTree = TreeView_GetChild(hTree,hFirstTree);
	while (rootTree)
	{
		if (!TreeView_GetItemText(hTree,rootTree,result)) return NULL;
		if (separators) 
		{
			char *ptr = strstr(result,separators);
			if (ptr) *ptr='\0';
		}
		if (!strcmp(result,value)) return rootTree;
		rootTree = TreeView_GetNextSibling(hTree,rootTree);
	} 
	return NULL;
}

void EnumModules(HWND hWndTreeExe,HTREEITEM hParentExe,HWND hWndTreeDll,DWORD pid,int *nbDll)
{
	HMODULE hMods[1024];
	HANDLE hProcess;
	DWORD cbNeeded;
	unsigned int i;
	MyString report;

	char exeName[MAX_PATH];
	char result[MAX_PATH];
	HTREEITEM hTreeTemp;
	
	TVINSERTSTRUCT elemTreeExe;
	elemTreeExe.hParent = hParentExe;
	elemTreeExe.hInsertAfter = TVI_LAST;							
	elemTreeExe.item.mask = TVIF_TEXT;
	elemTreeExe.item.pszText=result;
	elemTreeExe.item.cchTextMax=MAX_PATH;

	TVINSERTSTRUCT elemTreeDll;
	elemTreeDll.hParent = NULL;
	elemTreeDll.hInsertAfter = TVI_LAST;							
	elemTreeDll.item.mask = TVIF_TEXT ;
	elemTreeDll.item.pszText=result;
	elemTreeDll.item.cchTextMax=MAX_PATH;

	// Get a list of all the modules in this process.

	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION|PROCESS_VM_READ,FALSE,pid);
	if (!hProcess) return;

	if( EnumProcessModules(hProcess, hMods, sizeof(hMods), &cbNeeded))
	{
		for ( i = 0; i < (cbNeeded / sizeof(HMODULE)); i++ )
		{
			// Get the full path to the module's file.
			if ( GetModuleFileNameEx( hProcess, hMods[i], result,sizeof(result)))
			{
				_strlwr(result); // en minuscule
				FormatFileName(result);
				if (!i) 
				{
					strcpy(exeName,result); 
					BOOL res = TreeView_SetItemText(hWndTreeExe,hParentExe,exeName);
					continue;
				}
				TreeView_InsertItem(hWndTreeExe,&elemTreeExe);
				hTreeTemp = TreeView_FindText(hWndTreeDll,NULL,result);
				if (!hTreeTemp) 
				{
					hTreeTemp = TreeView_InsertItem(hWndTreeDll,&elemTreeDll);
					(*nbDll)++;
				}
				elemTreeDll.item.pszText=exeName;
				elemTreeDll.hParent=hTreeTemp;
				hTreeTemp = TreeView_InsertItem(hWndTreeDll,&elemTreeDll);
				elemTreeDll.item.pszText=result;
				elemTreeDll.hParent=NULL;
			}
		}
	}
	CloseHandle( hProcess );
}

BOOL GetProcessName(DWORD processID,char *processName,int stringSize)
{
	strcpy(processName,"Unknown");
	// Get a handle to the process.
	HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, processID );
	// Get the process name.
	if (hProcess)
	{
		HMODULE hMod;
		DWORD cbNeeded;
		if ( EnumProcessModules( hProcess, &hMod, sizeof(hMod), &cbNeeded) )
			GetModuleBaseName( hProcess, hMod, processName, stringSize);
		else { CloseHandle (hProcess) ; return FALSE; }
	}
	else return FALSE;
	CloseHandle (hProcess);
	return TRUE;
}

/* 
Methode a retenir car:
TreeView_SortChildren(hWndTree,NULL,TRUE); // (sens etre cursif)
fonctionne uniquement au premier niveau de hierarchie, pas au dela
 */
void TreeView_SortChildrenRecusively(HWND hWndTree,HTREEITEM item=NULL)
{
	TreeView_SortChildren(hWndTree,item,FALSE);
	HTREEITEM rootTree=TreeView_GetChild(hWndTree,item);
	while (rootTree)
	{
		TreeView_SortChildrenRecusively(hWndTree,rootTree);
		rootTree = TreeView_GetNextSibling(hWndTree,rootTree);
	} 
}

void EnumExe(HWND hWndTreeDll,HWND hWndTreeExe,int *nbDll,int *nbExe)
{
	TreeView_DeleteAllItems(hWndTreeDll);
	TreeView_DeleteAllItems(hWndTreeExe);

	HTREEITEM hTempTree;

	TVINSERTSTRUCT elemTree;
	elemTree.hParent = NULL;
	elemTree.hInsertAfter = TVI_LAST;							
	elemTree.item.mask = TVIF_TEXT ;
	char result[MAX_PATH];
	elemTree.item.pszText=result;
	elemTree.item.cchTextMax=MAX_PATH;

	MyString temp;
	DWORD aProcesses[1024], cbNeeded, cProcesses;
	unsigned int i;

	if (!EnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) ) return ;

	// Calculate how many process identifiers were returned.
	cProcesses = cbNeeded / sizeof(DWORD);

	*nbExe = 0;
	*nbDll = 0;
	// Print the name and process identifier for each process.
	for ( i = 0; i < cProcesses; i++ )
	{
		if (GetProcessName( aProcesses[i],result,MAX_PATH))
		{
			(*nbExe)++;
			_strlwr(result); // en minuscule
			FormatFileName(result);
			hTempTree = TreeView_InsertItem(hWndTreeExe,&elemTree);
			EnumModules(hWndTreeExe,hTempTree,hWndTreeDll,aProcesses[i],nbDll);
		}
	}
	TreeView_InsertTextNbCount(hWndTreeExe,NULL);
	TreeView_InsertTextNbCount(hWndTreeDll,NULL);

	TreeView_SortChildrenRecusively(hWndTreeExe);
	TreeView_SortChildrenRecusively(hWndTreeDll);
}

#include "windowsx.h"

void TreeView_ExpandAll (HWND hTree,HTREEITEM hFirstTree,BOOL expand,BOOL treeing)
{
	HTREEITEM root,child;
	if (!hFirstTree) root=TreeView_GetRoot(hTree);
	else root=hFirstTree;
	while (root)
	{
		if (treeing)
		{
			child = TreeView_GetChild(hTree,root);
			if (child) TreeView_ExpandAll(hTree,child,expand,treeing);
		}
		TreeView_Expand(hTree,root,expand? TVE_EXPAND : TVE_COLLAPSE);
		root = TreeView_GetNextSibling(hTree,root);
	} 
}

#include "TabCtrl.h"
#include "resizeWin.h"

typedef struct
{
	RECT rect;
	int mode;
	HWND hTree;
} TParam;

TParam param[2];
CTabCtrl *tab;

#define URL_HELP			"http://mignonsoft.free.fr/logiciel/#dllDependancy"
#define URL_FORUM			"http://www.cppfrance.com/code.aspx?ID=19391"
#define URL_LICENCE			"http://www.gnu.org/copyleft/gpl.html"
#define MAILTO				"mailto:sebastien.bloc@free.fr"

#include "utilsFile.h"

 LRESULT CALLBACK HelpProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
 {
	 switch (uMsg) 
	 {
	 case WM_INITDIALOG:
		 Edit_SetText(GetDlgItem(hDlg,IDC_RICHEDIT_TEXT),
			"Writing:		Sebastien Bloc\n"\
			"Copyright:	2004\n"\
			"eMail:		sebastien.bloc@free.fr\n"\
			"Licence:	OpenSource - GPL\n"\
			"URL:		www.mignonsoft.free.fr\n"\
			"\n"\
			"Goal:\n"\
			"* View DLL using inside EXE\n"\
			"* View EXE used inside DLL\n"\
			"\n"\
			"Using:\n"\
			"* Select viewpoint \"Exe on DLL\" -or- \"Dll on Exe\"\n"\
			"* Collaps your application or dll choice\n"\
			"* If you want to have dependancy final element, just double click on\n"\
			"* Press Refresh button if you want to update informations\n");
		 return TRUE;

	 case WM_COMMAND:
		 switch(wParam)
		 {
		 case IDOK:
		 case IDCANCEL:
			 EndDialog(hDlg, TRUE);
			 return TRUE;

		 case IDC_BUTTON_HELP:
			 MyOpenBrowser(URL_HELP);
			 EndDialog(hDlg, IDOK);
			 return TRUE;

		 case IDC_BUTTON_LICENCE:
			 MyOpenBrowser(URL_LICENCE);
			 EndDialog(hDlg, IDOK);
			 return TRUE;

		 case IDC_BUTTON_FORUM:
			 MyOpenBrowser(URL_FORUM);
			 EndDialog(hDlg, IDOK);
			 return TRUE;

		 case IDC_BUTTON_MAIL:
			 ShellExecute(NULL,"open",MAILTO,NULL,NULL,0);
			 EndDialog(hDlg, IDOK);
			 return TRUE;
		 }
	 }
	 return FALSE;
 }

LRESULT CALLBACK TreeProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TParam *paramCour = (TParam *) GetWindowLong ( hDlg, GWL_USERDATA ) ;

	switch (uMsg) 
	{
	case WM_SIZE:
		// Changement des tailles et position dans la fenetre
		int deltaX,deltaY;
		GetDeltaWindow(hDlg,&paramCour->rect,&deltaX,&deltaY);
		paramCour->hTree = GetDlgItem(hDlg,IDC_TREE_INFO);
		SetDeltaWindowSize(paramCour->hTree,deltaX,deltaY);
		InvalidateRect(hDlg,NULL,TRUE);
		return TRUE;

	case WM_INITDIALOG:
		paramCour = (TParam *) lParam; 
		SetWindowLong ( hDlg, GWL_USERDATA , (LONG)paramCour) ;
		GetWindowRect(hDlg,&paramCour->rect);
		return TRUE;

	case WM_NOTIFY:
		{
			int id = wParam;
			LPNMHDR pnmh = (LPNMHDR) lParam; 
			LPNMTREEVIEW pnmtv = (LPNMTREEVIEW) lParam;
			switch (id)
			{
			case IDC_TREE_INFO:
				switch (pnmh->code)
				{
				case NM_DBLCLK:
					{
						char result[MAX_PATH];
						// item en cours
						HTREEITEM hCurrentItem = TreeView_GetSelection(paramCour->hTree);
						// cette item est il terminal (sinon just ouverture du niveau)
						if (!TreeView_GetChild(paramCour->hTree,hCurrentItem))
						{
							// le text de l'element en cours
							TreeView_GetItemText(paramCour->hTree,hCurrentItem,result);
							// on ne garde que tout ce qui est avant le "
							//char *position = strstr(result,"[");
							//*position='\0';
							// on recherche dans l'autre table le meme element
							// rajour un espace car de l'autre cot 
							// la chaine est du type: Monfier.Extenssion   "c:\path\"  [x Elemts]
							strcat(result,"  "); 
							HWND hTreeOther = param[!paramCour->mode].hTree;
							HTREEITEM hOtherItem = TreeView_FindText(hTreeOther,NULL,result,"[");
							if (hOtherItem)
							{	// si trouv et normalement le cas contraire ne devrais jamais arriv
								TreeView_SelectItem(hTreeOther,hOtherItem);
								tab->ShowPage(!paramCour->mode);
							}
						}
					}
					break;
				}
				break;
			}
		}
	}
	return FALSE;
}

LRESULT CALLBACK MainProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static RECT rect;
	static HWND hWndTree=NULL;
	static HWND hTab;
	static HWND hTabPage[2];
	static int mode;
	// parsing des messages
	switch (uMsg) 
	{
	case WM_NOTIFY:
		tab->Notify(lParam);
		return TRUE;

	case WM_SIZE:
		// Changement des tailles et position dans la fenetre
		int deltaX,deltaY;
		GetDeltaWindow(hDlg,&rect,&deltaX,&deltaY);
		SetDeltaWindowSize(hTab,deltaX,deltaY);
		SetDeltaWindowSize(hTabPage[0],deltaX,deltaY);
		SetDeltaWindowSize(hTabPage[1],deltaX,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDC_BUTTON_REFRESH),0,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDC_BUTTON_COLLAPS),0,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDC_BUTTON_COLLAPS_ALL),0,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDC_BUTTON_EXPAND),0,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDC_BUTTON_EXPAND_ALL),0,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDC_BUTTON_HELP),deltaX,deltaY);
		SetDeltaWindowPos(GetDlgItem(hDlg,IDOK),deltaX,deltaY);
		InvalidateRect(hDlg,NULL,TRUE);
		return TRUE;

	case WM_INITDIALOG:
		hTab = GetDlgItem(hDlg,IDC_TAB_MODE);
		tab = new CTabCtrl(hTab);
		mode = 0;
		GetWindowRect(hDlg,&rect);

		param[0].mode=0;
		param[1].mode=1;
		hTabPage[0]= CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TREE),hTab,(DLGPROC)TreeProc,(LPARAM)&param[0]);
		tab->Add(hTabPage[0],"EXE dependancy");
		hTabPage[1]= CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TREE),hTab,(DLGPROC)TreeProc,(LPARAM)&param[1]);
		tab->Add(hTabPage[1],"DLL dependancy");
		tab->ShowPage(0);

		hWndTree=GetDlgItem(hTabPage[mode],IDC_TREE_INFO);

		PostMessage(hDlg,WM_COMMAND,IDC_BUTTON_REFRESH,NULL);
		return TRUE;

	case WM_COMMAND:
		switch(wParam)
		{
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, TRUE);
			return TRUE;

		case IDC_BUTTON_HELP:
			DialogBox(hInst,MAKEINTRESOURCE(IDD_HELP),hDlg,(DLGPROC)HelpProc);
			return TRUE;

		case IDC_BUTTON_REFRESH:
			{
				int nbExe,nbDll;
				EnumExe(param[1].hTree,param[0].hTree,&nbDll,&nbExe);
				MyString result;
				result.Format("EXE dependancy [%d Elems]",nbExe);
				tab->Rename(0,result);
				result.Format("DLL dependancy [%d Elems]",nbDll);
				tab->Rename(1,result);
			}
			return TRUE;

		case IDC_BUTTON_COLLAPS:
			TreeView_ExpandAll(hWndTree,TreeView_GetSelection(hWndTree),FALSE,FALSE);
			return TRUE;
		case IDC_BUTTON_COLLAPS_ALL:
			TreeView_ExpandAll(hWndTree,NULL,FALSE,TRUE);
			return TRUE;
		case IDC_BUTTON_EXPAND:
			TreeView_ExpandAll(hWndTree,TreeView_GetSelection(hWndTree),TRUE,FALSE);
			return TRUE;
		case IDC_BUTTON_EXPAND_ALL:
			TreeView_ExpandAll(hWndTree,NULL,TRUE,TRUE);
			return TRUE;
		}
	}
	return FALSE;
}


int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR     lpCmdLine,
					 int       nCmdShow)
{
	hInst = hInstance;
	LoadLibrary("riched32.dll");
	InitCommonControls(); // ajouter "comctl32.lib" dans les settings
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_MAIN),NULL,(DLGPROC)MainProc);
	return TRUE;
}

