#include <windows.h>
#include "MyRegistry.h"
#include <stdio.h>
#include "resizeWin.h"

// **************************************************************************************

BOOL GetDeltaWindow(HWND hWndParent,RECT *oldRect,int *deltaX,int *deltaY)
{
	RECT newRect;

	GetWindowRect(hWndParent,&newRect);
	*deltaX = (newRect.right-newRect.left)-(oldRect->right-oldRect->left);
	*deltaY = (newRect.bottom-newRect.top)-(oldRect->bottom-oldRect->top);

	CopyMemory(oldRect,&newRect,sizeof(RECT));
	return TRUE;
}

// **************************************************************************************

BOOL SetDeltaWindowSize(HWND hWndControl,int deltaX,int deltaY)
{
	RECT rect;

	GetWindowRect(hWndControl,&rect);
	int dX = rect.right-rect.left;
	int dY= rect.bottom-rect.top;

	SetWindowPos(hWndControl,NULL,0,0,dX+deltaX,dY+deltaY,SWP_NOMOVE|SWP_NOZORDER|SWP_NOREDRAW|SWP_NOACTIVATE|SWP_NOCOPYBITS|SWP_NOSENDCHANGING);
	return TRUE;
}

// **************************************************************************************

BOOL SetDeltaWindowPos(HWND hWndControl,int deltaX,int deltaY)
{
	POINT point;
	RECT rect;
	GetWindowRect(hWndControl,&rect);
	point.x=rect.left;
	point.y=rect.top;
	HWND hWndParent = GetParent(hWndControl);
	ScreenToClient(hWndParent,&point);
	SetWindowPos(hWndControl,NULL,point.x+deltaX,point.y+deltaY,0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_NOREDRAW|SWP_NOACTIVATE|SWP_NOCOPYBITS|SWP_NOSENDCHANGING);	
	return TRUE;
}