
//#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <shellapi.h>
#include <string.h>
#pragma comment(lib, "shlwapi.lib") // ajouter Shlwapi.lib dans les seting link
#include <shlwapi.h>
//#include <native.h>
#include "utilsFile.h"
#include "myString.h"

#define TS_NO_FILE		1
#define TS_OK			2		
#define TS_ERROR_SIZE	3


/* ---------------------------------------------------------------------------------------------------
	Donne la taille d'un fichier + macros pour simplifier la vie de l'ouvrirer programmeur !
--------------------------------------------------------------------------------------------------- */

DWORD MyFileSize(char *fileName)
{
	DWORD size;
	HANDLE hF;

	hF = CreateFileA (fileName, GENERIC_READ, FILE_SHARE_READ ,NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN , NULL) ;
	if (hF == INVALID_HANDLE_VALUE) size = -1;
	else
	{
		size = GetFileSize(hF,NULL);
		CloseHandle(hF);
	}
	return size;
}


/* ---------------------------------------------------------------------------------------------------
	Test la taille d'un fichier
--------------------------------------------------------------------------------------------------- */

int MyTestSize(char *fileName,long size) 
{
	if (! fileName[0]) return TS_OK;
	if (!PathFileExistsA(fileName)) return TS_NO_FILE;
	if (size == -1) return  TS_OK;
	return (unsigned)MyFileSize(fileName) == (unsigned)size ? TS_OK : TS_ERROR_SIZE;
}


/* ------------------------------------------------------------------------------------------------
	Cree un repertoire et les sous repertoires s'il n'existe pas 
------------------------------------------------------------------------------------------------ */
//ex : "c:\rep1\rep2\"

BOOL MyMkDir(char *dir)
{
	char dirCpy[MAX_PATH];
	char current[MAX_PATH];

	strcpy(dirCpy,dir);
	char *find = dirCpy;

	while (find = strchr(find,'\\'))
	{
		strncpy(current,dirCpy,find-dirCpy+1);
		current[find-dirCpy+1]='\0';

		if (!PathIsDirectory(current))
		{
			if (!CreateDirectory (current,NULL)) return FALSE;
		}

		find ++;
	}
	return TRUE;
}


/* ------------------------------------------------------------------------------------------------
	Efface tout les fichier d'un repertoire (peut etre un joker style "*.*" ou "*.dat")
------------------------------------------------------------------------------------------------ */

BOOL MyDelFile (char *curDir,char *file)
{
	HANDLE hFichCour;
	WIN32_FIND_DATA wfd ;
	char temp[MAX_PATH];
			
	sprintf(temp,"%s\\%s",curDir,file);
	hFichCour = FindFirstFile (temp, &wfd) ;

	if (hFichCour != INVALID_HANDLE_VALUE) 
	{
		do 
		{
			if (wfd.cFileName[0]!='.')
			{
				sprintf(temp,"%s\\%s",curDir,wfd.cFileName);
				if (!DeleteFile(temp)) return FALSE;
			}
		} 
		while (FindNextFile (hFichCour, &wfd ));
	}
	else return FALSE;

	FindClose (hFichCour) ;

	return TRUE;
}


/* ------------------------------------------------------------------------------------------------
	La fameuse fonction DOS qui efface recursivement un repertoire non vide
------------------------------------------------------------------------------------------------ */

int MyDelTree (char *curDir)
{
	if (!MyDelFile(curDir,"*.*")) return FALSE;
	if (!RemoveDirectory(curDir)) return FALSE;
	return TRUE;
}

/* --------------------------------------------------------------------------------------------------
	Ouvre un browser internet
-------------------------------------------------------------------------------------------------- */

void MyOpenBrowser(char *url)
{
	char Browser[MAX_PATH];
    char RegPath[MAX_PATH + MAX_PATH];
	char RegValue [MAX_PATH + MAX_PATH] ;
	DWORD DataSize = MAX_PATH;
	static HINSTANCE hShell=NULL;
	DWORD type = REG_SZ ;
    HKEY hKey;

    RegOpenKeyEx(HKEY_CLASSES_ROOT, ".htm", 0, KEY_QUERY_VALUE, &hKey);
    RegQueryValueEx(hKey,NULL,NULL,&type,(unsigned char *)RegPath,&DataSize);
    RegCloseKey(hKey);

	strcat(RegPath,"\\shell\\open\\command");
    DataSize = MAX_PATH*2; type = REG_SZ ;
	RegOpenKeyEx(HKEY_CLASSES_ROOT, RegPath,0, KEY_QUERY_VALUE ,&hKey) ;
	RegQueryValueEx(hKey,NULL,NULL,&type,(unsigned char *)RegValue,&DataSize) ;

    RegCloseKey(hKey);

	char *pos = strstr(RegValue,"\"%1\"");
	if(!pos )    
	{   
		pos = strstr(RegValue,"%1");
		if(pos == NULL) pos = RegValue+strlen(RegValue)-1;
		else  *pos = '\0';    
	} else *pos = '\0'; 
	pos = strstr(RegValue, " -") ; 
	if (pos != NULL) *pos = '\0' ;
	char *q = Browser ;
	for (size_t i = 0; i < strlen (RegValue) ; i++) 
	{
		if (RegValue[i] != '\"') 
		{
			*q = RegValue[i];
			q++ ;
		}
	}
	*q = '\0' ;

	ShellExecute(NULL,"open",Browser,url,NULL,SW_SHOW);
}

// *************************************************************************************************************************

BOOL GetFullM3UPath (MyString &pathCur,MyString &m3uPath,MyString &fullPath)
{
	fullPath = "";
	if (m3uPath[0]=='\\') fullPath <<pathCur[0]<<":"<<m3uPath;
	else fullPath <<pathCur<<"\\"<<m3uPath;
	return TRUE;
}

// *************************************************************************************************************************

char * GetPathAndFile (MyString &pathFile)
{
	
	for (int i=1;i<=pathFile.size;i++)
	{
		if (pathFile[-i]=='\\') { pathFile[-i]='\0'; break; }
	}
	if (!i) return NULL;
	return pathFile.value+pathFile.size-i+1;
}


// **********************************************************************************************

DWORD CheckSumFile (char *fileName)
{
	return CheckSumFile(fileName,FALSE,0,MyFileSize(fileName));
}

// **********************************************************************************************

DWORD CheckSumFile (char *fileName,DWORD sizeCheck)
{
	return CheckSumFile(fileName,TRUE,0,sizeCheck);
}

// **********************************************************************************************

DWORD CheckSumFile (char *fileName,BOOL isSizeCompute,DWORD dataBeginPos,DWORD dataEndPos)
{
	FILE *fich;
	fich = fopen(fileName,"rt");
	if (fich == NULL) return FALSE;

	// pour differencier les fichiers ayant la meme signature mais de taille differante
	DWORD testSize =  dataEndPos-dataBeginPos;
	DWORD checkSum = isSizeCompute ? MyFileSize(fileName) : testSize;

	unsigned char data[BUFFER_SIZE];

	DWORD sumByteRead = 0;
	DWORD byteRead;
	DWORD i;

	fseek(fich,dataBeginPos,SEEK_SET);
	BOOL isContinue = TRUE;

	while (isContinue)
	{	
		byteRead = fread((void *)data,sizeof(char),BUFFER_SIZE,fich);
		if (!byteRead) isContinue = FALSE;
		else
		{
			sumByteRead += byteRead;
			if (sumByteRead >= testSize) 
			{
				byteRead -= sumByteRead-testSize;
				isContinue = FALSE;
			}

			// checkSum equation:
			// [0-255]*[1-9]
			// donne*(pos%9+1)  

			for (i=0;i<byteRead;i++)
			{
				checkSum += data[i]*((i%9)+1); 
			}
		}
	}
	fclose (fich);
	return checkSum;
}